#include <bits/stdc++.h>

using namespace std;

long int kizar(long int n)
{
    long int meddig=sqrt(n), jelenlegi=0;

    for(long int i=1;i<=meddig;i++)
    {
        if(n%i==0)
        {
            jelenlegi=jelenlegi^i;
            if(n/i != i)
            {
              jelenlegi=jelenlegi^(n/i);
            }
            else
            {
                jelenlegi=jelenlegi^i;
                break;

            }
        }
    }


    return jelenlegi;
}




int main()
{

    long int n, k;
    cin>>n>>k;

    vector<long int> osztok(k);
    for(long int i=0;i<k;i++)
    {
        cin>>osztok.at(i);
    }


    for(long int i=0;i<k;i++)
    {
       cout<<kizar(a.at(i))<<" ";
    }






    return 0;
}